<template>
    <transition name="modal">
        <div class="modal-mask" @click="closeModal">
            <div class="modal-wrapper">
                <div class="modal-container">
                    <div class="modal-header">
                        Добавление новой задачи
                    </div>
                    <div class="modal-body">
                        <form v-model="task" @submit.prevent="onSubmit">
                            <div class="mb-2">
                                    <label for="task-name" class="block text-gray-700 text-sm font-bold mb-2">Задача</label>
                                    <textarea id="task-name" ref="inputTaskName" class=" appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline" v-model="task.name"></textarea>
                            </div>
                            <div class="mb-2">
                                <label for="task-time" class="block text-gray-700 text-sm font-bold mb-2">Время</label>
                                <input v-model="task.time" class="appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline" id="task-time"  type="number">
                            </div>
                            <div class="flex items-center justify-between">
                                <button class="bg-blue-400 hover:bg-blue-dark text-white w-full font-bold mt-4 py-2 px-4 rounded focus:outline-none focus:shadow-outline" type="submit">
                                    Добавить
                                </button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </transition>
</template>

<script>
  import uuid from 'uuid';

  export default {
    name: 'add-task',
    data() {
      return {
        task: { name: '', time: null },
      };
    },
    mounted() {
      this.$refs.inputTaskName.focus();
    },
    methods: {
      clearTask() {
        this.task = { name: '', time: null };
      },
      onSubmit() {
        if (this.task.name && this.task.time) {
          const newTask = {
            id: uuid(),
            name: this.task.name,
            time: this.task.time || 0,
          };
          this.clearTask();
          this.$emit('onSubmit', newTask);
        }
      },
      closeModal(event) {
        const { target } = event;
        if (target.classList.contains('modal-wrapper')) {
          this.clearTask();
          this.$emit('close');
        }
      },
    },
  };
</script>

<style scoped>
    .modal-mask {
        position: fixed;
        z-index: 9998;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        background-color: rgba(0, 0, 0, .5);
        display: table;
        transition: opacity .3s ease;
    }

    .modal-wrapper {
        display: table-cell;
        vertical-align: middle;
    }

    .modal-container {
        width: 400px;
        margin: 0px auto;
        padding: 20px 30px;
        background-color: #fff;
        border-radius: 2px;
        box-shadow: 0 2px 8px rgba(0, 0, 0, .33);
        transition: all .3s ease;
        font-family: Helvetica, Arial, sans-serif;
    }

    .modal-header {
        text-align: center;
        font-size: 18px;
        color: #4a5568;
        font-weight: 600;
    }

    .modal-body {
        margin: 20px 0;
    }

    .modal-default-button {
        float: right;
    }

    .modal-enter {
        opacity: 0;
    }

    .modal-leave-active {
        opacity: 0;
    }

    .modal-enter .modal-container,
    .modal-leave-active .modal-container {
        -webkit-transform: scale(1.1);
        transform: scale(1.1);
    }
</style>
